# coding: utf-8

"""
    Pathnexus

    Pathnexus - a lab data harmonisation platform  # noqa: E501

    OpenAPI spec version: 5.8.0
    Contact: support@termlex.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from pathnexus.com.termlex.pathnexus.model.search_category import SearchCategory  # noqa: F401,E501


class SearchResults(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'results': 'list[object]',
        'categories': 'list[SearchCategory]'
    }

    attribute_map = {
        'results': 'results',
        'categories': 'categories'
    }

    def __init__(self, results=None, categories=None):  # noqa: E501
        """SearchResults - a model defined in Swagger"""  # noqa: E501

        self._results = None
        self._categories = None
        self.discriminator = None

        if results is not None:
            self.results = results
        if categories is not None:
            self.categories = categories

    @property
    def results(self):
        """Gets the results of this SearchResults.  # noqa: E501


        :return: The results of this SearchResults.  # noqa: E501
        :rtype: list[object]
        """
        return self._results

    @results.setter
    def results(self, results):
        """Sets the results of this SearchResults.


        :param results: The results of this SearchResults.  # noqa: E501
        :type: list[object]
        """

        self._results = results

    @property
    def categories(self):
        """Gets the categories of this SearchResults.  # noqa: E501


        :return: The categories of this SearchResults.  # noqa: E501
        :rtype: list[SearchCategory]
        """
        return self._categories

    @categories.setter
    def categories(self, categories):
        """Sets the categories of this SearchResults.


        :param categories: The categories of this SearchResults.  # noqa: E501
        :type: list[SearchCategory]
        """

        self._categories = categories

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SearchResults):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
